# Plugins Arguments

- [pluginArguments](#pluginArguments) : <code>object</code>
  - [.layout](#pluginArguments.layout) : <code>object</code>
  - [.keys](#pluginArguments.keys) : <code>object</code>
    - [.SCALE](#pluginArguments.keys.SCALE) : <code>object</code>
      - [.MAIN](#pluginArguments.keys.SCALE.MAIN) : <code>object</code>
        - [.MINOR](#pluginArguments.keys.SCALE.MAIN.MINOR) : <code>string</code>
        - [.MAJOR](#pluginArguments.keys.SCALE.MAIN.MAJOR) : <code>string</code>
    - [.COMPONENT](#pluginArguments.keys.COMPONENT) : <code>object</code>
      - [.BAR](#pluginArguments.keys.COMPONENT.BAR) : <code>string</code>
      - [.BAR_AXIS](#pluginArguments.keys.COMPONENT.BAR_AXIS) : <code>string</code>
      - [.Y_AXIS](#pluginArguments.keys.COMPONENT.Y_AXIS) : <code>string</code>
      - [.MEASURE_TITLE](#pluginArguments.keys.COMPONENT.MEASURE_TITLE) : <code>string</code>
      - [.DIMENSION_TITLE](#pluginArguments.keys.COMPONENT.DIMENSION_TITLE) : <code>string</code>
    - [.COLLECTION](#pluginArguments.keys.COLLECTION) : <code>object</code>
      - [.MAIN](#pluginArguments.keys.COLLECTION.MAIN) : <code>string</code>

---

<a name="pluginArguments.layout"></a>

### pluginArguments.layout : <code>object</code>

The layout from the enigma model.

**Kind**: static property of [<code>pluginArguments</code>](#pluginArguments)  
<a name="pluginArguments.keys"></a>

### pluginArguments.keys : <code>object</code>

The keys (references) to different types of chart internals

**Kind**: static property of [<code>pluginArguments</code>](#pluginArguments)

- [.keys](#pluginArguments.keys) : <code>object</code>
  - [.SCALE](#pluginArguments.keys.SCALE) : <code>object</code>
    - [.MAIN](#pluginArguments.keys.SCALE.MAIN) : <code>object</code>
      - [.MINOR](#pluginArguments.keys.SCALE.MAIN.MINOR) : <code>string</code>
      - [.MAJOR](#pluginArguments.keys.SCALE.MAIN.MAJOR) : <code>string</code>
  - [.COMPONENT](#pluginArguments.keys.COMPONENT) : <code>object</code>
    - [.BAR](#pluginArguments.keys.COMPONENT.BAR) : <code>string</code>
    - [.BAR_AXIS](#pluginArguments.keys.COMPONENT.BAR_AXIS) : <code>string</code>
    - [.Y_AXIS](#pluginArguments.keys.COMPONENT.Y_AXIS) : <code>string</code>
    - [.MEASURE_TITLE](#pluginArguments.keys.COMPONENT.MEASURE_TITLE) : <code>string</code>
    - [.DIMENSION_TITLE](#pluginArguments.keys.COMPONENT.DIMENSION_TITLE) : <code>string</code>
  - [.COLLECTION](#pluginArguments.keys.COLLECTION) : <code>object</code>
    - [.MAIN](#pluginArguments.keys.COLLECTION.MAIN) : <code>string</code>

<a name="pluginArguments.keys.SCALE"></a>

#### keys.SCALE : <code>object</code>

The scales associated with the bar chart
They are useful if you want to, via plugin, add a new component that
uses the same scale as one of the measures.

**Kind**: static property of [<code>keys</code>](#pluginArguments.keys)

- [.SCALE](#pluginArguments.keys.SCALE) : <code>object</code>
  - [.MAIN](#pluginArguments.keys.SCALE.MAIN) : <code>object</code>
    - [.MINOR](#pluginArguments.keys.SCALE.MAIN.MINOR) : <code>string</code>
    - [.MAJOR](#pluginArguments.keys.SCALE.MAIN.MAJOR) : <code>string</code>

<a name="pluginArguments.keys.SCALE.MAIN"></a>

##### SCALE.MAIN : <code>object</code>

The main scales

**Kind**: static property of [<code>SCALE</code>](#pluginArguments.keys.SCALE)

- [.MAIN](#pluginArguments.keys.SCALE.MAIN) : <code>object</code>
  - [.MINOR](#pluginArguments.keys.SCALE.MAIN.MINOR) : <code>string</code>
  - [.MAJOR](#pluginArguments.keys.SCALE.MAIN.MAJOR) : <code>string</code>

<a name="pluginArguments.keys.SCALE.MAIN.MINOR"></a>

###### MAIN.MINOR : <code>string</code>

The main minor scale

**Kind**: static property of [<code>MAIN</code>](#pluginArguments.keys.SCALE.MAIN)  
<a name="pluginArguments.keys.SCALE.MAIN.MAJOR"></a>

###### MAIN.MAJOR : <code>string</code>

The main major scale

**Kind**: static property of [<code>MAIN</code>](#pluginArguments.keys.SCALE.MAIN)  
<a name="pluginArguments.keys.COMPONENT"></a>

#### keys.COMPONENT : <code>object</code>

The unique keys of the existing components available in the chart.
They are useful if you want to extend or override the existing components.

**Kind**: static property of [<code>keys</code>](#pluginArguments.keys)

- [.COMPONENT](#pluginArguments.keys.COMPONENT) : <code>object</code>
  - [.BAR](#pluginArguments.keys.COMPONENT.BAR) : <code>string</code>
  - [.BAR_AXIS](#pluginArguments.keys.COMPONENT.BAR_AXIS) : <code>string</code>
  - [.Y_AXIS](#pluginArguments.keys.COMPONENT.Y_AXIS) : <code>string</code>
  - [.MEASURE_TITLE](#pluginArguments.keys.COMPONENT.MEASURE_TITLE) : <code>string</code>
  - [.DIMENSION_TITLE](#pluginArguments.keys.COMPONENT.DIMENSION_TITLE) : <code>string</code>

<a name="pluginArguments.keys.COMPONENT.BAR"></a>

##### COMPONENT.BAR : <code>string</code>

The bar component

**Kind**: static property of [<code>COMPONENT</code>](#pluginArguments.keys.COMPONENT)  
<a name="pluginArguments.keys.COMPONENT.BAR_AXIS"></a>

##### COMPONENT.BAR_AXIS : <code>string</code>

The bar axis component

**Kind**: static property of [<code>COMPONENT</code>](#pluginArguments.keys.COMPONENT)  
<a name="pluginArguments.keys.COMPONENT.Y_AXIS"></a>

##### COMPONENT.Y_AXIS : <code>string</code>

The y axis component

**Kind**: static property of [<code>COMPONENT</code>](#pluginArguments.keys.COMPONENT)  
<a name="pluginArguments.keys.COMPONENT.MEASURE_TITLE"></a>

##### COMPONENT.MEASURE_TITLE : <code>string</code>

The measure title component

**Kind**: static property of [<code>COMPONENT</code>](#pluginArguments.keys.COMPONENT)  
<a name="pluginArguments.keys.COMPONENT.DIMENSION_TITLE"></a>

##### COMPONENT.DIMENSION_TITLE : <code>string</code>

The dimension title component

**Kind**: static property of [<code>COMPONENT</code>](#pluginArguments.keys.COMPONENT)  
<a name="pluginArguments.keys.COLLECTION"></a>

#### keys.COLLECTION : <code>object</code>

The data collections the users can use to get data from

**Kind**: static property of [<code>keys</code>](#pluginArguments.keys)  
<a name="pluginArguments.keys.COLLECTION.MAIN"></a>

##### COLLECTION.MAIN : <code>string</code>

The main data collection

**Kind**: static property of [<code>COLLECTION</code>](#pluginArguments.keys.COLLECTION)

# Definitions
